/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.cosmodas.FacadeCosmos;

import com.cosmodas.EntCosmos.VproductosRequisicion;

import java.util.ArrayList;
import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

/**
 * @author obper
 */
@Stateless
public class VproductosRequisicionFacade extends AbstractFacade<VproductosRequisicion> implements VproductosRequisicionFacadeLocal {

    @PersistenceContext(unitName = "wcosmodasPersistent")
    private EntityManager em;

    @Override
    protected EntityManager getEntityManager() {
        return em;
    }

    public VproductosRequisicionFacade() {
        super(VproductosRequisicion.class);
    }

    @Override
    public List<VproductosRequisicion> obtenerProductosBusqueda(String programaCodigo, String sucursalCodigo) {
        List<VproductosRequisicion> rs = new ArrayList<>();
        rs = em.createNativeQuery("{CALL pproducto_requisicion(?,?)}",
                        VproductosRequisicion.class)
                .setParameter(1, sucursalCodigo)
                .setParameter(2, programaCodigo).getResultList();


        if (rs.get(0) != null) {
            return rs;

        }else{
            return new ArrayList<>();
        }

    }

    @Override
    public VproductosRequisicion busquedaPorCodigo(String sucursalCodigo, String programaCodigo, String productoCodigo) {
        VproductosRequisicion rs = new VproductosRequisicion();

        rs = (VproductosRequisicion) em.createNativeQuery("{CALL pproducto_requisicion_porp(?,?,?)}",
                VproductosRequisicion.class)
                .setParameter(1, sucursalCodigo)
                .setParameter(2, programaCodigo)
                .setParameter(3, productoCodigo).getResultList().get(0);
        return rs;

    }

    @Override
    public List<VproductosRequisicion> busquedaPorNombre(String sucursalCodigo, String programaCodigo, String productoNombre) {
        List<VproductosRequisicion> rs = new ArrayList<>();

        rs = em.createNativeQuery("{CALL pproducto_requisicion_pornom(?,?,?)}",
                VproductosRequisicion.class)
                .setParameter(1, sucursalCodigo)
                .setParameter(2, programaCodigo)
                .setParameter(3, productoNombre).getResultList();
        return rs;

    }
}